<template>
  <component :is="componentTag" v-bind="componentProps">
    <span v-if="icon || $slots.left">
      <!--
        @slot Use this slot for custom icons (i.e.: with custom classes)
      -->
      <slot name="left"><rui-icon :name="icon" :title="caption || ''" /></slot>
    </span>

    <!--
      @slot Visible text
    -->
    <span v-if="caption || $slots.default" class="rui-button__text"><slot>{{ caption }}</slot></span>

    <span v-if="endIcon || $slots.right">
      <!--
        @slot Use this slot for custom icons (i.e.: with custom classes)
      -->
      <slot name="right"><rui-icon :name="endIcon" /></slot>
    </span>
  </component>
</template>

<script>
import RuiIcon from '../Icon/Icon.vue'

const variants = ['destructive', 'creative', 'recording', 'canceling', 'helping', 'dim']
const sizes = ['small', 'large']
const types = ['button', 'submit', 'reset']

/**
 * Button component with support for `vue-router` links, anchor links and more !
 *
 * @preset default { "props": { "caption": "Click me!" } }
 */
export default {
  name: 'RuiButton',
  components: { RuiIcon },
  props: {
    /** Main content. Will be overridden by default slot content */
    caption: { required: false, type: [String, Number], default: null },
    /**
     * Color variant
     *
     * @values destructive, creative, recording, canceling, helping, dim
     */
    variant: { required: false, type: String, default: null, validator: v => variants.includes(v) },
    /**
     * Button size
     *
     * @values small, large
     */
    size: { required: false, type: String, default: null, validator: v => sizes.includes(v) },
    /** Takes full available width */
    block: { required: false, type: Boolean, default: false },
    /** Whether the button is rendered without background */
    text: { required: false, type: Boolean, default: false },
    /** Force active state */
    active: { required: false, type: Boolean, default: false },
    /** Makes the button non-responsive to clicks. Useful with "blank" icons */
    noAction: { required: false, type: Boolean, default: false },
    /** Left icon name */
    icon: { required: false, type: String, default: null },
    /** Right icon name */
    endIcon: { required: false, type: String, default: null },
    /** Router-link route. Will render a link styled like a button. */
    to: { required: false, type: [Object, String], default: null },
    /** Link URL. Will render a link styled like a button. */
    href: { required: false, type: String, default: null },
    /**
     * Button type (will be ignored when used with `to` or `href`
     *
     * @values button, submit, reset
     */
    type: { required: false, type: String, default: 'button', validator: v => types.includes(v) },
    /** Whether to hide the text on small screens */
    noTextOnSmall: { required: false, type: Boolean, default: false },
    /** Whether to disable the button/link */
    disabled: { required: false, type: Boolean, default: false },
  },
  computed: {
    componentTag () {
      if (this.to) return 'RouterLink'
      if (this.href) return 'a'

      return 'button'
    },
    componentProps () {
      const props = {
        class: [
          'rui-button',
          this.size && `rui-button--${this.size}`,
          this.block && 'rui-button--block',
          this.text && 'rui-button--text',
          this.active && 'rui-button--active',
          this.noAction && 'rui-button--no-action',
          this.noTextOnSmall && 'rui-button--no-text-on-small',
          this.disabled && 'rui-button--disabled',
          variants.includes(this.variant) && this.text && `rui-button--text--${this.variant}`,
          variants.includes(this.variant) && !this.text && `rui-button--${this.variant}`,
        ],
        disabled: this.disabled,
      }

      if (this.to) {
        props.to = this.to
      } else if (this.href) {
        props.href = this.href
      } else {
        props.type = this.type
      }

      return props
    },
  },
}
</script>
